<?php

namespace Controllers;

use \Teknisa\GER\Utilities\MessagesProcedureInflightor;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class AlteracaoPlanoDeVooController extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName;
    protected $parameterBagColumns = array();

    public function __construct($crudService, $parameterBag,  $environment,
    $dataSourceManager, $connection, $MessagesProcedure) {
        $this->crudService = $crudService;
        $this->parameterBag=$parameterBag;
        $this->environment=$environment;
        $this->dataSourceManager = $dataSourceManager;
        $this->connection = $connection;
        $this->MessagesProcedure = $MessagesProcedure;
    }

    public function findFilial (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'filioper_filial';
        $filterCriteria = $request->getFilterCriteria();

        $filterCriteria->addCondition('CDOPERADOR', "=", $this->environment->getCdOperador());
        $this->parameterBagColumns = array("CDOPERADOR");


        parent::find($request, $response);

    }

    public function findCiaVoo (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'ciafili_planovoom_companhia';
        $this->parameterBagColumns = array("CDFILIAL", "DTHRPLAVOOPV");

        parent::find($request, $response);
    }

    public function findVooCia (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'vootrecho_planovoom_base';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "DTHRPLAVOOPV");


        parent::find($request, $response);

    }

    public function findPrevPax (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'previsaopaxm_operador_classe_ciclo_companhia_planovoom';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO", "CDCLASSE", "DTHRPLAVOOPV", "CDTRECHO" );

        parent::find($request, $response);
    }

    public function findInfo (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'logprevpaxm_operador';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO", "CDCLASSE", "DTHRPLAVOOPV", "CDTRECHO" );

        parent::find($request, $response);
    }

    public function findServPlanoVoo (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'servplanom_classe_ciclo_servciclo_servicociafili_servicogen';
        $this->parameterBagColumns = array("NRORG", "CDFILIAL", "CDCIA", "NRVOO", "DTHRPLAVOOPV", "CDTRECHO" );

        parent::find($request, $response);
    }

    public function findClassePaxDif  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'previsaopaxm_classecia_classe_dif';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO", "DTHRPLAVOOPV", "CDTRECHO" );

        parent::find($request, $response);
    }

    public function findTrecho  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'vootrecho_base_base';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO");

        parent::find($request, $response);
    }

    public function findCaracVoo  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'voo_planovoo';
        $this->parameterBagColumns = array("NRVOO", "DTHRPLAVOOPV");

        parent::find($request, $response);


    }

    public function findProporcao  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'servplanom_padvootrem';
        $this->parameterBagColumns = array("NRVOO", "CDTRECHO", "DTHRPLAVOOPV", "NRSERVICOCIAFILI");

        parent::find($request, $response);
    }

    public function findServicosVoo  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'servicociafili_servicogen_servciclo_precoseciam_tabprecose_previsaopaxm_classe_ciclo';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO", "CDTRECHO", "DTHRPLAVOOPV", "NRSERVICOCIAFILI");

        parent::find($request, $response);
    }

    public function findPlanovooEquipamentoVoo  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'planovoom_equipamento_voo';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "DTHRPLAVOOPV", "NRVOO", "CDTRECHO", "NRORG");

        parent::find($request, $response);
    }

    public function findEquipciaEquip  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'equipcia_equipamento';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA");

        parent::find($request, $response);
    }

    public function findPrefixo  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'prefixocia_equipcia_equipamento';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA");

        parent::find($request, $response);
    }

    public function findParamsVoo  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'planovoom_equipamento_vootrecho';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO", "CDTRECHO", "DTHRPLAVOOPV");
        parent::find($request, $response);
    }

    public function findIdservico (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'servicogen_servicociafili_idservico';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRSERVICOCIAFILI", "NRORG");
        parent::find($request, $response);
    }

    public function findVRQTOTAL  (DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'configvoo_configpref_configequi';
        $this->parameterBagColumns = array("CDFILIAL", "CDCIA", "NRVOO", "CDTRECHO", "SGPREFIXO", "CDCLASSE", "CDEQUIP");
        parent::find($request, $response);
    }

    public function retorna_ciclom (DTO\Request\Row $request, DTO\Response $response) {
        try {

            $row = $request->getRow();
            $cdfilial = $row['CDFILIAL'];
            $cdcia = $row['CDCIA'];
            $nrvoo = $row['NRVOO'];
            $cdtrecho = $row['CDTRECHO'];
            $dthrplavoopv = $row['DTHRPLAVOOPV'];
            $cdclasse = $row['CDCLASSE'];
            $nrservicociafili = NULL;
            $cdciclo="";

            $response->addDataset(new DataSet('response', $this->retorna_ciclo($cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv,
            $nrservicociafili, $cdclasse, $cdciclo)));

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }

    }

    public function retorna_ciclo($cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv, $nrservicociafili, $cdclasse, $cdciclo){
        $procedure = new StoredProcedure($this->connection, 'RETORNA_CICLOM');
        $procedure->addParam(new Param('P_CDFILIAL',           Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('P_CDCIA',              Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('P_NRVOO',              Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('P_CDTRECHO',           Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV',       Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('P_NRSERVICOCIAFILI',   Param::PARAM_INPUT, $nrservicociafili));
        $procedure->addParam(new Param('P_CDCLASSE',           Param::PARAM_INPUT, $cdclasse));
        $procedure->addParam(new Param('P_CDCICLO_GER',        Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_NULL,10));

        $result = $procedure->execute();

        $arrayResult = array();
        $arrayResult['CDCICLO'] = $result['P_CDCICLO_GER'];

        return $arrayResult;
    }

    public function exclui_planovoom (DTO\Request\Row $request, DTO\Response $response) {
         try {

            $row = $request->getRow();
            $cdfilial = $row['CDFILIAL'];
            $cdcia = $row['CDCIA'];
            $nrvoo = $row['NRVOO'];
            $cdtrecho = $row['CDTRECHO'];
            $dthrplavoopv = $row['DTHRPLAVOOPV'];

            $this->EXCLUIR_PLANOVOOM($cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv);

        } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    public function EXCLUIR_PLANOVOOM ( $cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv){
        $procedure = new StoredProcedure($this->connection, 'EXCLUI_PLANOVOOM');
        $procedure->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('P_CDCIA',        Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('P_NRVOO',        Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('P_CDTRECHO',     Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV', Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('P_NRORG',        Param::PARAM_INPUT, $this->environment->getNrOrg()));
        $result = $procedure->execute();

        $arrayResult = array();
        return $arrayResult;
    }

    public function retorna_agrupamento (DTO\Request\Row $request, DTO\Response $response) {
        try {

            $row = $request->getRow();
            $cdfilial = $row['CDFILIAL'];
            $cdcia = $row['CDCIA'];
            $nrvoo = $row['NRVOO'];
            $cdtrecho = $row['CDTRECHO'];
            $cdclasse = $row['CDCLASSE'];
            $cdequip = $row['CDEQUIP'];
            $sgprefixo = $row['SGPREFIXO'];

            $response->addDataset(new DataSet('response', $this->RETORNA_AGRUPAMENTOM($row)));

        } catch (\Exception $e) {
            $erro = $e->getMessage();
            if(strpos($erro,"¿#Evoo_AgDel")>0) {
                $response->setError(new Error("ATE01500_AGRUPAMENTO_DEL_N_ENCONTRADO", 500));
            } else {
                $response->setError(new Error($e->getMessage(), 500));
            }
        }

    }

    public function RETORNA_AGRUPAMENTOM($row){
        $procedure = new StoredProcedure($this->connection, 'RETORNA_AGRUPAMENTO');

        $procedure->addParam(new Param('P_CDFILIAL',           Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',              Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',              Param::PARAM_INPUT, $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',           Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_CDCLASSE',           Param::PARAM_INPUT, $row['CDCLASSE']));
        $procedure->addParam(new Param('P_CDEQUIP',            Param::PARAM_INPUT, $row['CDEQUIP']));
        $procedure->addParam(new Param('P_SGPREFIXO',           Param::PARAM_INPUT, $row['SGPREFIXO']));
        $procedure->addParam(new Param('P_CDAGRDECO',        Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_NULL,10));

        $result = $procedure->execute();

        $arrayResult = array();
        $arrayResult['CDAGRDECO'] = $result['P_CDAGRDECO'];

        return $arrayResult;
    }

    public function calculaPrecom (DTO\Request\Row $request, DTO\Response $response) {
        $localError = false;
        try {
            $row = $request->getRow();
            $rowCalculaPrecom = array();
            $rowCalculaPrecom['IDINDICE'] = 'N';
            $rowCalculaPrecom['CDFILIAL'] = $row['CDFILIAL'];
            $rowCalculaPrecom['CDCIA'] = $row['CDCIA'];
            $rowCalculaPrecom['NRVOO'] = $row['NRVOO'];
            $rowCalculaPrecom['CDTRECHO'] = $row['CDTRECHO'];
            $rowCalculaPrecom['NRSERVICOCIAFILI'] = $row['NRSERVICOCIAFILI'];
            $rowCalculaPrecom['CDCLASSE'] = $row['CDCLASSE'];
            $rowCalculaPrecom['CDCICLO'] = $row['CDCICLO'];
            $rowCalculaPrecom['DTHRPLAVOOPV'] = $row['DTHRPLAVOOPV'];
            $rowCalculaPrecom['DTHRABASTPV'] = $row['DTHRABASTPV'];

            $rowCalculaPrecom['IDCALCPROPDLCOM'] = $row['IDCALCPROPDLCOM'];
            if(!isset($row['QTTOTPAXAT'])) {
                $localError = true;
                throw new \Exception("ATE01500_CLASSE_N_CAD_PLANOVOO");
            }

            if($row['IDCALCPROPDLCOM'] === 'S') {
                $rowCalculaPrecom['QTTOTPAX_PAXSBY'] = $row['QTREALPROD'] + $row['QTTOTPAXAT'];
                $rowCalculaPrecom['QTSERFATSP'] = $row['QTREALPROD'] + $row['QTATUAPRODSP'];
            }else {
                $rowCalculaPrecom['QTTOTPAX_PAXSBY'] = $row['QTTOTPAXAT'];
                $rowCalculaPrecom['QTSERFATSP'] = $row['QTATUAPRODSP'];
            }
            $response->addDataset(new DataSet('response', $this->CALCULA_PRECOM($rowCalculaPrecom)));

        } catch (\Exception $e) {
            if($localError) {
                 $response->setError(new Error($e->getMessage(), 500));
            } else {
                $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
            }
        }

    }

    public function CALCULA_PRECOM($rowCalculaPrecom) {
            $procedure = new StoredProcedure($this->connection, 'CALCULA_PRECOM');
            $procedure->addParam(new Param('P_IDINDICE',            Param::PARAM_INPUT, $rowCalculaPrecom['IDINDICE']));
            $procedure->addParam(new Param('P_CDFILIAL',            Param::PARAM_INPUT, $rowCalculaPrecom['CDFILIAL']));
            $procedure->addParam(new Param('P_CDCIA',               Param::PARAM_INPUT, $rowCalculaPrecom['CDCIA']));
            $procedure->addParam(new Param('P_NRVOO',               Param::PARAM_INPUT, $rowCalculaPrecom['NRVOO']));
            $procedure->addParam(new Param('P_CDTRECHO',            Param::PARAM_INPUT, $rowCalculaPrecom['CDTRECHO']));
            $procedure->addParam(new Param('P_NRSERVICOCIAFILI',    Param::PARAM_INPUT, $rowCalculaPrecom['NRSERVICOCIAFILI']));
            $procedure->addParam(new Param('P_CDCLASSE',            Param::PARAM_INPUT, $rowCalculaPrecom['CDCLASSE']));
            $procedure->addParam(new Param('P_CDCICLO',             Param::PARAM_INPUT, $rowCalculaPrecom['CDCICLO']));
            $procedure->addParam(new Param('P_DTHRPLAVOOPV',        Param::PARAM_INPUT, $rowCalculaPrecom['DTHRPLAVOOPV']));
            $procedure->addParam(new Param('P_DTHRABASTPV',         Param::PARAM_INPUT, $rowCalculaPrecom['DTHRABASTPV']));
            $procedure->addParam(new Param('P_QTTOTPAX_PAXSBY',     Param::PARAM_INPUT, $rowCalculaPrecom['QTTOTPAX_PAXSBY']));
            $procedure->addParam(new Param('P_QTSERFATSP',          Param::PARAM_INPUT, $rowCalculaPrecom['QTSERFATSP']));
            $procedure->addParam(new Param('IDCALCPROPDLCOM',          Param::PARAM_INPUT, $rowCalculaPrecom['IDTIPMANUALSP']));
            $procedure->addParam(new Param('P_VRPRECORRENTE',       Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_NULL,10));
            $procedure->addParam(new Param('P_VRPREDOLAR',          Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_NULL,10));
            $result = $procedure->execute();
            $arrayResult = array();
            $arrayResult['VRPRECORRENTE'] = $result['P_VRPRECORRENTE'];
            $arrayResult['VRPREDOLAR'] = $result['P_VRPREDOLAR'];
            return $arrayResult;

    }

    public function incluiClasseVoom (DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $rowIncluiClasseVoo = array();
            $rowIncluiClasseVoo['CDFILIAL'] = $row['CDFILIAL'];
            $rowIncluiClasseVoo['CDCIA'] = $row['CDCIA'];
            $rowIncluiClasseVoo['NRVOO'] = $row['NRVOO'];
            $rowIncluiClasseVoo['CDTRECHO'] = $row['CDTRECHO'];
            $rowIncluiClasseVoo['CDCLASSE'] = $row['CDCLASSE'];
            $rowIncluiClasseVoo['DTHRPLAVOOPV'] = $row['DTHRPLAVOOPV'];
            $rowIncluiClasseVoo['CDOPERADOR'] = $this->crudService->getEnvironment()->getCdOperador();

            $response->addDataset(new DataSet('response', $this->INCLUI_CLASSE_VOO($rowIncluiClasseVoo)));

        } catch (\Exception $e) {
           $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }

    }

    public function INCLUI_CLASSE_VOO($rowIncluiClasseVoo) {
            $procedure = new StoredProcedure($this->connection, 'INCLUI_CLASSE_VOOM');
            $procedure->addParam(new Param('P_CDFILIAL',            Param::PARAM_INPUT, $rowIncluiClasseVoo['CDFILIAL']));
            $procedure->addParam(new Param('P_CDCIA',               Param::PARAM_INPUT, $rowIncluiClasseVoo['CDCIA']));
            $procedure->addParam(new Param('P_NRVOO',               Param::PARAM_INPUT, $rowIncluiClasseVoo['NRVOO']));
            $procedure->addParam(new Param('P_CDTRECHO',            Param::PARAM_INPUT, $rowIncluiClasseVoo['CDTRECHO']));
            $procedure->addParam(new Param('P_DTHRPLAVOOPV',        Param::PARAM_INPUT, $rowIncluiClasseVoo['DTHRPLAVOOPV']));
            $procedure->addParam(new Param('P_CDCLASSE',            Param::PARAM_INPUT, $rowIncluiClasseVoo['CDCLASSE']));
            $procedure->addParam(new Param('P_CDOPERADOR',          Param::PARAM_INPUT, $rowIncluiClasseVoo['CDOPERADOR']));

            $result = $procedure->execute();
            $arrayResult = array();

            return $arrayResult;

    }

    public function trocaEquipamentom (DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $rowTrocaEquipamento = array();
            $rowTrocaEquipamento['CDFILIAL'] = $row['CDFILIAL'];
            $rowTrocaEquipamento['CDCIA'] = $row['CDCIA'];
            $rowTrocaEquipamento['NRVOO'] = $row['NRVOO'];
            $rowTrocaEquipamento['CDTRECHO'] = $row['CDTRECHO'];
            $rowTrocaEquipamento['DTHRPLAVOOPV'] = $row['DTHRPLAVOOPV'];
            $rowTrocaEquipamento['P_DTHRABASTPV'] = $row['DTHRABASTPV'];
            $rowTrocaEquipamento['CDOPERADOR'] = $this->environment->getCdOperador();
            $rowTrocaEquipamento['CDEQUIP'] = $row['CDEQUIP'];
            $rowTrocaEquipamento['SGPREFIXO'] = $row['SGPREFIXO'];

            $response->addDataset(new DataSet('response', $this->TROCA_EQUIPAMENTOM($rowIncluiClasseVoo)));
        } catch (\Exception $e) {
           $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));

        }
    }

    public function TROCA_EQUIPAMENTOM($rowTrocaEquipamento) {

            $procedure = new StoredProcedure($this->connection, 'TROCA_EQUIPM');
            $procedure->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $rowTrocaEquipamento['CDFILIAL']));
            $procedure->addParam(new Param('P_CDCIA',        Param::PARAM_INPUT, $rowTrocaEquipamento['CDCIA']));
            $procedure->addParam(new Param('P_NRVOO',        Param::PARAM_INPUT, $rowTrocaEquipamento['NRVOO']));
            $procedure->addParam(new Param('P_CDTRECHO',     Param::PARAM_INPUT, $rowTrocaEquipamento['CDTRECHO']));
            $procedure->addParam(new Param('P_DTHRPLAVOOPV', Param::PARAM_INPUT, $rowTrocaEquipamento['DTHRPLAVOOPV']));
            $procedure->addParam(new Param('P_DTHRABASTPV',  Param::PARAM_INPUT, $rowTrocaEquipamento['DTHRABASTPV']));
            $procedure->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $rowTrocaEquipamento['CDOPERADOR']));
            $procedure->addParam(new Param('P_CDEQUIP',      Param::PARAM_INPUT, $rowTrocaEquipamento['CDEQUIP']));
            $procedure->addParam(new Param('P_NRORG',        Param::PARAM_INPUT, $rowTrocaEquipamento['NRORG']));

            $result = $procedure->execute();
            $arrayResult = array();

            return $arrayResult;
    }

    public function cancelaPlanoVoom (DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $rowCancelaPlanoVoom = array();
            $rowCancelaPlanoVoom['CDFILIAL'] = $row['CDFILIAL'];
            $rowCancelaPlanoVoom['CDCIA'] = $row['CDCIA'];
            $rowCancelaPlanoVoom['NRVOO'] = $row['NRVOO'];
            $rowCancelaPlanoVoom['CDTRECHO'] = $row['CDTRECHO'];
            $rowCancelaPlanoVoom['DTHRPLAVOOPV'] = $row['DTHRPLAVOOPV'];
            $rowCancelaPlanoVoom['TIPOOPER'] = $row['TIPOOPER'];


            $response->addDataset(new DataSet('response', $this->CANCELA_PLANO_VOOM($rowCancelaPlanoVoom)));

        } catch (\Exception $e) {
           $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    public function CANCELA_PLANO_VOOM($rowCancelaPlanoVoom) {

            $procedure = new StoredProcedure($this->connection, 'CANCELA_PLANO_VOOM');
            $procedure->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $rowCancelaPlanoVoom['CDFILIAL']));
            $procedure->addParam(new Param('P_CDCIA',        Param::PARAM_INPUT, $rowCancelaPlanoVoom['CDCIA']));
            $procedure->addParam(new Param('P_NRVOO',        Param::PARAM_INPUT, $rowCancelaPlanoVoom['NRVOO']));
            $procedure->addParam(new Param('P_CDTRECHO',     Param::PARAM_INPUT, $rowCancelaPlanoVoom['CDTRECHO']));
            $procedure->addParam(new Param('P_DTHRPLAVOOPV', Param::PARAM_INPUT, $rowCancelaPlanoVoom['DTHRPLAVOOPV']));
            $procedure->addParam(new Param('P_TIPOOPER',     Param::PARAM_INPUT, $rowCancelaPlanoVoom['TIPOOPER']));
            $procedure->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $this->environment->getCdOperador()));
            $procedure->addParam(new Param('P_NRORG',        Param::PARAM_INPUT, $this->environment->getNrOrg()));

            $result = $procedure->execute();
            $arrayResult = array();

            return $arrayResult;
    }

// ------------------ NOVA IMPLEMENTAÇÃO --------------------------
    public function saveClassOnManutencaoPlanoVoo($request, $response){
        $rows = $request->getDataSet()->getRows();
        $paxExcedente = array();
        $rowsToSave = array();
        $this->connection->beginTransaction();
        try{
            foreach($rows as $classe){
                $classe = (array)$classe;
                $classe['CDOPERADOR'] = $this->crudService->getEnvironment()->getCdOperador();
                if(!$classe['ignoreMaxPax']) {
                    $classeMaxima = $this->getMaximaClasse($classe);
                    if(!empty($classeMaxima)){
                        $classeMaxima = $classeMaxima[0];
                        $maximaTotal = intval($classeMaxima['QTPAX']) + intval($classeMaxima['QTPAXSBY']);
                        $totalClasse = intval($classe['QTTOTPAXAT']) + intval($classe['QTPAXSBY']);
                        if($maximaTotal < $totalClasse){
                            $classe['ignoreMaxPax'] = true;
                            $paxExcedente[] = $classe;
                        } else {
                            $rowsToSave[] = $classe;
                        }
                    } else {
                        $rowsToSave[] = $classe;
                    }
                } else {
                    $rowsToSave[] = $classe;
                }
            }
            if(!empty($rowsToSave)){
                $rowsToSave = $this->mountRowsToSaveClasse($rowsToSave);
                $this->crudService->save('previsaopaxm', $rowsToSave);
                $this->incluiClasseVooDataSet($rowsToSave);
            }
            $this->connection->commit();
            $response->addDataset(new DataSet('previsaopaxm', $paxExcedente));
        } catch(\Exception $e){
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
            $this->connection->rollback();
        }
    }
    
    
    public function conxaoSubGrup($rows){
        $cdfilial = $rows[0]['CDFILIAL'];
        $cdcia = $rows[0]['CDCIA'];
        $nrvoo = $rows[0]['NRVOO'];
        $cdtrecho = $rows[0]['CDTRECHO'];
        $dthrplavoopv = $rows[0]['DTHRPLAVOOPV'];
        $dtref = $rows[0]['DTHRABASTPV'];
        $nrservicociafili = $rows[0]['NRSERVICOCIAFILI'];
        $cdclasse = $rows[0]['CDCLASSE'];
        $cdciclo = $rows[0]['CDCICLO'];
        $nritemplansp = $rows[0]['NRITEMPLANSP'];
        $validacao = "N";
        
        
        $procedure = new StoredProcedure($this->connection, 'CONEXAO_COM_SUBGRU_PLANOVOOM');
        $procedure->addParam(new Param('CDFILIAL',          Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('CDCIA',             Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('NRVOO',             Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('CDTRECHO',          Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('DTHRPLAVOOPV',      Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('NRSERVICOCIAFILI',  Param::PARAM_INPUT, $nrservicociafili));
        $procedure->addParam(new Param('CDCLASSE',          Param::PARAM_INPUT, $cdclasse));
        $procedure->addParam(new Param('CDCICLO',           Param::PARAM_INPUT, $cdciclo));
        $procedure->addParam(new Param('DTREF',             Param::PARAM_INPUT, $dtref));
        $procedure->addParam(new Param('VALIDACAO',         Param::PARAM_INPUT, $validacao));
        $procedure->addParam(new Param('NRITEMPLANSP',      Param::PARAM_INPUT, $nritemplansp));
        $procedure->addParam(new Param('CDOPERADOR',        Param::PARAM_INPUT, $this->environment->getCdOperador()));
        $procedure->addParam(new Param('NRORG',             Param::PARAM_INPUT, $this->environment->getNrOrg()));
        $procedure->addParam(new Param('MSGERRO',           Param::PARAM_OUTPUT, null));
        
        $result = $procedure->execute();
    }

    private function getMaximaClasse($row){
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $row['CDFILIAL']
            ),
            array(
                'columnName' => 'CDCIA',
                'operator' => '=',
                'value' => $row['CDCIA']
            ),
            array(
                'columnName' => 'CDTRECHO',
                'operator' => '=',
                'value' => $row['CDTRECHO']
            ),
            array(
                'columnName' => 'NRVOO',
                'operator' => '=',
                'value' => $row['NRVOO']
            ),
            array(
                'columnName' => 'CDCLASSE',
                'operator' => '=',
                'value' => $row['CDCLASSE']
            )
        );
        $dataSet = $this->crudService->getFilteredDataSet('config_pax_voo', $conditions);
        return $dataSet->getRows();
    }

    private function mountRowsToSaveClasse($rows){
        $dataSet = new DataSet('previsaopaxm', $rows);
        $newRequest = new DTO\Request\DataSet($dataSet, '','','');
        return $this->crudService->getRowsToSave($newRequest, 'previsaopaxm');
    }

    private function incluiClasseVooDataSet($dataSet){
        if($dataSet[0]['__is_new']){
            $this->INCLUI_CLASSE_VOO($dataSet[0]);
        } else {
            foreach($dataSet as $classe){
                $this->ALTERA_CLASSE_PLANOVOOM($classe);
            }
        }
    }

    public function validaSitucao($request, $response){
        $row = (array)$request->getRow();
        $situacaoVoo = $this->getSituacaoVoo($row);
        $this->setSituacaoVoo($situacaoVoo);
    }

    private function setSituacaoVoo($params){
        $sql = "UPDATE PLANOVOOM
                SET IDSITABASPV = NVL(:SITUACAO, IDSITABASPV)
                WHERE CDFILIAL = :P_CDFILIAL AND
                CDCIA = :P_CDCIA AND
                NRVOO = :P_NRVOO AND
                CDTRECHO = :P_CDTRECHO AND
                DTHRPLAVOOPV = :P_DTHRPLAVOOPV";

        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll()[0];

    }

    private function getSituacaoVoo($row){
        $sql = "SELECT SUM(CASE WHEN IDSITSERSP = '1' THEN 1 ELSE 0 END) AS QTDE_PENDENTE,
                SUM(CASE WHEN IDSITSERSP = '2' AND NRDELIVERY IS NOT NULL THEN 1 ELSE 0 END) AS QTDE_EMITIDO,
                COUNT(1) AS QTDE_TOTAL
                FROM SERVPLANOM
                WHERE CDFILIAL = :P_CDFILIAL AND
                CDCIA = :P_CDCIA AND
                NRVOO = :P_NRVOO AND
                CDTRECHO = :P_CDTRECHO AND
                DTHRPLAVOOPV = :P_DTHRPLAVOOPV";
        $params = array(
            'P_CDFILIAL' => $row['CDFILIAL'],
            'P_CDCIA' => $row['CDCIA'],
            'P_NRVOO' => $row['NRVOO'],
            'P_CDTRECHO' => $row['CDTRECHO'],
            'P_DTHRPLAVOOPV' => $row['DTHRPLAVOOPV']
        );

        $query = $this->connection->prepare($sql);
        $query->execute($params);
        $result = $query->fetchAll();

        $situacao = '';
        if($result['QTDE_PENDENTE']>0){
            $situacao = '1';
        } else if($result['QTDE_EMITIDO'] = $result['QTDE_TOTAL']) {
            $result = '2';
        } else {
            $situacao = null;
        }

        $params['SITUACAO'] =$situacao;
        return $params;
    }

    public function manutencaoPlanovoo($request, $response){
        $row = (array)$request->getRow();
        try {
            $this->connection->beginTransaction();

            $rowsToSave = $this->crudService->getRowsToSave($request, 'planovoom');
            $this->crudService->save('planovoom', $rowsToSave);
            if($row['ATUALIZAR']){
                $row['CDOPERADOR'] = $this->environment->getCdOperador();
                $this->TROCA_EQUIPAMENTOM($row);
            }
            $this->connection->commit();
        } catch(\Exception $e){
            $this->connection->rollback();
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }
    
    private function getCdAgrDeco($cdfilial, $cdcia, $nrvoo, $cdtrecho, $cdclasse, $nrorg, $nritemplansp, $dthrplavoopv) {
        
        $sql = "SELECT CDAGRDECO FROM SERVPLANOM
                WHERE CDFILIAL = :CDFILIAL AND
	        CDCIA = :CDCIA AND
	        NRVOO = :NRVOO AND
	        CDCLASSE = :CDCLASSE AND
	        CDTRECHO = :CDTRECHO AND
	        NRORG = :NRORG AND
	        NRITEMPLANSP = :NRITEMPLANSP AND
	        DTHRPLAVOOPV = :DTHRPLAVOOPV";
                
        $params = array(
            'CDFILIAL' => $cdfilial,
            'CDCIA' => $cdcia,
            'NRVOO' => $nrvoo,
            'CDTRECHO' => $cdtrecho,
            'CDCLASSE' => $cdclasse,
            'NRORG' => $nrorg,
            'NRITEMPLANSP' => $nritemplansp,
            'DTHRPLAVOOPV' => $dthrplavoopv
        );

        $query = $this->connection->prepare($sql);
        
        $query->execute($params);
        
        $result = $query->fetch(\PDO::FETCH_ASSOC);
        
        return $result['CDAGRDECO'];
        
    }

    private function calcularDelivery($rows) {

        for($i=0; $i < count($rows); $i++) {

            $item = $rows[$i];

            $nrorg = isset($item['NRORG']) ? $item['NRORG'] : $this->environment->getNrOrg();
            $cdagrdeco = $this->getCdAgrDeco($item['CDFILIAL'], $item['CDCIA'], $item['NRVOO'], $item['CDTRECHO'], $item['CDCLASSE'], $nrorg, $item['NRITEMPLANSP'], $item['DTHRPLAVOOPV']);

            $cdfilial = $rows[$i]['CDFILIAL'];
            $cdcia = $rows[$i]['CDCIA'];
            $nrvoo = $rows[$i]['NRVOO'];
            $cdtrecho = $rows[$i]['CDTRECHO'];
            $dthrplavoopv = $rows[$i]['DTHRPLAVOOPV'];
            $cdlocafatcia = isset($rows[$i]['CDLOCAFATCIA']) ? $rows[$i]['CDLOCAFATCIA'] : null;
            $cdlocafatcia = null;
            $nrseqdeliver = 0;

            $procedure = new StoredProcedure($this->connection, 'CALCULA_DELIVERYM');
            $procedure->addParam(new Param('NRDELIVERY',         Param::PARAM_INPUT, null));
            $procedure->addParam(new Param('CDFILIAL',           Param::PARAM_INPUT, $cdfilial));
            $procedure->addParam(new Param('CDCIA',              Param::PARAM_INPUT, $cdcia));
            $procedure->addParam(new Param('NRVOO',              Param::PARAM_INPUT, $nrvoo));
            $procedure->addParam(new Param('CDTRECHO',           Param::PARAM_INPUT, $cdtrecho));
            $procedure->addParam(new Param('DTHRPLAVOOPV',       Param::PARAM_INPUT, $dthrplavoopv));
            $procedure->addParam(new Param('CDAGRDECO',          Param::PARAM_INPUT, $cdagrdeco));
            $procedure->addParam(new Param('CDLOCAFATCIA',       Param::PARAM_INPUT, $cdlocafatcia));
            $procedure->addParam(new Param('NRSEQDELIVER',       Param::PARAM_INPUT, $nrseqdeliver));
            $procedure->addParam(new Param('CDOPERADOR',         Param::PARAM_INPUT, $this->environment->getCdOperador()));
            $procedure->addParam(new Param('PESOTOTSERV',        Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('TOTALGERALSERV',     Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('VRTAXA',             Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('DESCNOTA',           Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('DESCSERV',           Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('DESCDESV',           Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('PEDESCDESV',         Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('DESCFIXO',           Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('PEDESCFIXO',         Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('DESCCOND',           Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('PEDESCCOND',         Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('TOTSBYUT',           Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('TOTSBYNUT',          Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('VRTOTDESC',          Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('VRUTIDESC',          Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('IDDESCDESV',         Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('IDDESCCOND',         Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('IDDESCFIXO',         Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('IDINCDESDESV',       Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('IDINCDESFIXO',       Param::PARAM_OUTPUT, null,null, 20));
            $procedure->addParam(new Param('IDINCDESCOND',       Param::PARAM_OUTPUT, null,null, 20));

            $result = $procedure->execute();

        }

    }

    public function saveInlineItensFaturamento($request, $response){
        $rows = $request->getDataSet()->getRows();
        if($rows) {
            $messages = array();
            try{
                $this->connection->beginTransaction();
                $planovoom = $this->getPlanovoom($rows[0]);
                if($rows[0]['__is_new']){
                    $row = $rows[0];
                    $this->executeProceduresToItem($row, $planovoom, $messages);
                    $this->saveItem(array($row), $planovoom);
                    
                    if($row['IDEXCECAO'] == "N"){
                        $this->linkItemFatSubgrupo($row, $planovoom);
                    }
                    
                } else{
                    foreach($rows as $item){
                        $this->executeProceduresToItem($item, $planovoom, $messages);
                    }
                    $this->saveItem($rows, $planovoom);
                    
                    if($rows[0]['IDEXCECAO'] == "N")
                        $this->conxaoSubGrup($rows);
                        
                }
                $this->calcularDelivery($rows);
                if(!empty($messages)){
                    $response->setError(new Error($messages, 500));
                    $this->connection->rollback();
                } else {
                    $this->connection->commit();
                }
            } catch (\Exception $e){
                $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
                $this->connection->rollback();
            }
        }
    }

    private function linkItemFatSubgrupo($row, $planovoom){
        $procedure = new StoredProcedure($this->connection, 'CONEXAO_COM_SUBGRU_PLANOVOOM');

        $procedure->addParam(new Param('P_CDFILIAL',         Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',            Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',            Param::PARAM_INPUT, $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',         Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV',     Param::PARAM_INPUT, $row['DTHRPLAVOOPV']));
        $procedure->addParam(new Param('P_NRSERVICOCIAFILI', Param::PARAM_INPUT, $row['NRSERVICOCIAFILI']));
        $procedure->addParam(new Param('P_CDCLASSE',         Param::PARAM_INPUT, $row['CDCLASSE']));
        $procedure->addParam(new Param('P_CDCICLO',          Param::PARAM_INPUT, $row['CDCICLO']));
        $procedure->addParam(new Param('P_DTREF',            Param::PARAM_INPUT, $planovoom['DTHRABASTPV']));
        $procedure->addParam(new Param('P_VALIDACAO',        Param::PARAM_INPUT, 'N'));
        $procedure->addParam(new Param('P_NRITEMPLANSP',     Param::PARAM_INPUT, $row['NRITEMPLANSP']));
        $procedure->addParam(new Param('P_CDOPERADOR',       Param::PARAM_INPUT, $this->environment->getCdOperador()));
        $procedure->addParam(new Param('P_NRORG',            Param::PARAM_INPUT, $this->environment->getNrOrg()));
        $procedure->addParam(new Param('P_QTSESOLICSP',      Param::PARAM_OUTPUT,null,Param::PARAM_TYPE_NULL, 10));
        $result = $procedure->execute();
    }

    private function validateItem($row, &$messages){
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $row['CDFILIAL']
            ),
            array(
                'columnName' => 'CDCIA',
                'operator' => '=',
                'value' => $row['CDCIA']
            ),
            array(
                'columnName' => 'CDTRECHO',
                'operator' => '=',
                'value' => $row['CDTRECHO']
            ),
            array(
                'columnName' => 'NRVOO',
                'operator' => '=',
                'value' => $row['NRVOO']
            ),
            array(
                'columnName' => 'CDCLASSE',
                'operator' => '=',
                'value' => $row['CDCLASSE']
            ),
            array(
                'columnName' => 'CDCICLO',
                'operator' => '=',
                'value' => $row['CDCICLO']
            ),
            array(
                'columnName' => 'DTHRPLAVOOPV',
                'operator' => '=',
                'value' => $row['DTHRPLAVOOPV']
            ),
            array(
                'columnName' => 'NRSERVICOCIAFILI',
                'operator' => '=',
                'value' => $row['NRSERVICOCIAFILI']
            ),
            array(
                'columnName' => 'NRITEMPLANSP',
                'operator' => '=',
                'value' => $row['NRITEMPLANSP']
            )
        );

        $valid = true;
        $items = $this->crudService->getFilteredDataSet('servplanom', $conditions)->getRows();
        if(!empty($items)){
            $item = $items[0];
            $status = $this->getSituacaoItemDelivery($item['CDFILIAL'], $item['CDCIA'], $item['NRVOO'], $item['CDTRECHO'], $item['CDCLASSE'], $item['NRORG'], $item['NRITEMPLANSP'], $item['DTHRPLAVOOPV']);
            if($status['IDSITSERSP'] == '2'){
                $valid = false;
                $messages[] = "ATE01500_SERV_EMIT" . "#_#" . $row['DSSERVICOCIAFILI'];
            } else if($status['IDSITSERSP'] == '3'){
                $valid = false;
                $messages[] = "ATE01500_SERV_CANCEL" . "#_#" . $row['DSSERVICOCIAFILI'];
            }
        }
        return $valid;

    }

    private function executeProceduresToItem(&$row, $planovoom, &$messages){
        $row['SGPREFIXO'] = $planovoom['SGPREFIXO'];
        $row['CDEQUIP'] = $planovoom['CDEQUIP'];
        $row['DTHRABASTPV'] = $planovoom['DTHRABASTPV'];
        if($this->validateItem($row, $messages)){
            $resultPrecom = $this->CALCULA_PRECOM($row);
            $row['VRPRURESESP'] = $resultPrecom['VRPRECORRENTE'];
            $row['VRPRUDOLSESP'] = $resultPrecom['VRPREDOLAR'];
            $resultAgrupamento = $this->RETORNA_AGRUPAMENTOM($row);
            $row['CDAGRDECO'] = $resultAgrupamento['CDAGRDECO'];
        }
    }

    private function saveItem($rows, $planovoom){
        $this->verificaNovoRegistro($rows);
        $dataSave = new DataSet('servplanom', $rows);
        $requestSave = new DTO\Request\DataSet($dataSave, '','','');
        $dataSave = $this->crudService->getRowsToSave($requestSave, 'servplanom');
        $this->crudService->save('servplanom', $dataSave);
        $this->REVALIDA_STATUS_PLANOVOOM($planovoom);
    }
    
    private function verificaNovoRegistro(&$rows){
        if($rows[0]["__is_new"] && $rows[0]["NRITEMPLANSP"] == null){
            $itensDeFaturamento = $this->findItensFaturamento($rows[0]);
            $rows[0]['NRITEMPLANSP'] = sizeof($itensDeFaturamento) + 1;
        }
    }
    
    private function findItensFaturamento($row){
        $filtro = array(
            array(
                "columnName" => "CDFILIAL",
                "operator" => "=",
                "value"=> $row['CDFILIAL']
            ),
            array(
                "columnName" => "CDCIA",
                "operator" => "=",
                "value"=> $row['CDCIA']
            ),
            array(
                "columnName" => "NRVOO",
                "operator" => "=",
                "value"=> $row['NRVOO']
            ),
            array(
                "columnName" => "DTHRPLAVOOPV",
                "operator" => "=",
                "value"=> $row['DTHRPLAVOOPV']
            ),
            array(
                "columnName" => "CDTRECHO",
                "operator" => "=",
                "value"=> $row['CDTRECHO']
            )
        );
        
        $filterCriteria = new FilterCriteria('servplanom_classe_ciclo_servciclo_servicociafili_servicogen', $filtro);
        $newFilterCriteria = $this->crudService->getPopulatedFilterCriteria($filterCriteria, array("NRORG", "CDFILIAL", "CDCIA", "NRVOO", "DTHRPLAVOOPV", "CDTRECHO" ));
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        
        return $dataSet->getRows();
        
    }
    
    private function REVALIDA_STATUS_PLANOVOOM($row){
        $procedure = new StoredProcedure($this->connection, 'REVALIDA_STATUS_PLANOVOOM');

        $procedure->addParam(new Param('P_CDFILIAL',     Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',        Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',        Param::PARAM_INPUT, $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',     Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV', Param::PARAM_INPUT, $row['DTHRPLAVOOPV']));
        $procedure->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $this->environment->getCdOperador()));
        $procedure->addParam(new Param('P_NRORG',        Param::PARAM_INPUT, $row['NRORG']));
        $result = $procedure->execute();
    }

    private function getPlanovoom($row){
        $conditions = array(
            array(
                'columnName' => 'CDFILIAL',
                'operator' => '=',
                'value' => $row['CDFILIAL']
            ),
            array(
                'columnName' => 'CDCIA',
                'operator' => '=',
                'value' => $row['CDCIA']
            ),
            array(
                'columnName' => 'NRVOO',
                'operator' => '=',
                'value' => $row['NRVOO']
            ),
            array(
                'columnName' => 'DTHRPLAVOOPV',
                'operator' => '=',
                'value' => $row['DTHRPLAVOOPV']
            ),
            array(
                'columnName' => 'CDTRECHO',
                'operator' => '=',
                'value' => $row['CDTRECHO']
            )
        );
        $dataSetPlanoVoo = $this->crudService->getFilteredDataSet('planovoom', $conditions)->getRows();
        return $dataSetPlanoVoo[0];
    }

    public function calculaQuantidadesM($request, $response){
        $row = (array)$request->getRow();
        try{
            $this->connection->beginTransaction();
            $planoVoom = $this->getPlanovoom($row);
            $row['DTHRABASTPV'] = $planoVoom['DTHRABASTPV'];
            $responseProcedure = $this->CALCULA_QUANTIDADESM($row);
            $response->addDataSet(new DataSet('response', array($responseProcedure)));
            $this->connection->commit();
        } catch(\Exception $e){
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
            $this->connection->rollback();
        }
    }

    private function CALCULA_QUANTIDADESM($row){
        $procedure = new StoredProcedure($this->connection, 'CALCULA_QUANTIDADESM');

        $procedure->addParam(new Param('P_CDFILIAL',         Param::PARAM_INPUT,        $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',            Param::PARAM_INPUT,        $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',            Param::PARAM_INPUT,        $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',         Param::PARAM_INPUT,        $row['CDTRECHO']));
        $procedure->addParam(new Param('P_NRSERVICOCIAFILI', Param::PARAM_INPUT,        $row['NRSERVICOCIAFILI']));
        $procedure->addParam(new Param('P_CDCLASSE',         Param::PARAM_INPUT,        $row['CDCLASSE']));
        $procedure->addParam(new Param('P_CDCICLO',          Param::PARAM_INPUT,        $row['CDCICLO']));
        $procedure->addParam(new Param('P_DTREF',            Param::PARAM_INPUT,        $row['DTHRABASTPV']));
        $procedure->addParam(new Param('P_QTTOTPAX',         Param::PARAM_INPUT,        $row['QTTOTPAXAT'])); //quantidade total da classe correspondente
        $procedure->addParam(new Param('P_IDPROPSERV',       Param::PARAM_INPUT_OUTPUT, $row['IDTIPSCBOSP']));
        $procedure->addParam(new Param('P_QTSESOLICSP',      Param::PARAM_OUTPUT,       null,                        Param::PARAM_TYPE_NULL, 10)); //quantidade solicitada;
        $procedure->addParam(new Param('P_QTSESBYPRSP',      Param::PARAM_INPUT_OUTPUT, $row['QTSESBYPRSP'],         Param::PARAM_TYPE_NULL, 10)); //quantidade standby do serviço
        $procedure->addParam(new Param('P_NRPROP',           Param::PARAM_INPUT_OUTPUT, $row['NRPROPAXSP'],          Param::PARAM_TYPE_NULL, 10)); //Quantidade da proporcao fixa
        $procedure->addParam(new Param('P_VRPELOAD',         Param::PARAM_INPUT_OUTPUT, $row['VRLOADSESP'],          Param::PARAM_TYPE_NULL, 10)); //Quantidade de load
        $procedure->addParam(new Param('P_QTFIX',            Param::PARAM_INPUT_OUTPUT, $row['QTSERVFIXSP'],         Param::PARAM_TYPE_NULL, 10)); //quantidade Fixa
        $procedure->addParam(new Param('P_QTSERVFAT',        Param::PARAM_OUTPUT,       null,                        Param::PARAM_TYPE_NULL, 10)); //Quantidade de faturamento

        $result = $procedure->execute();
        $arrayResult = array();
        $arrayResult['QTPAX'] = $result['P_QTSESOLICSP'];
        $arrayResult['QTSBY'] = $result['P_QTSESBYPRSP'];
        return $arrayResult;
    }

    public function cancelClasse($request, $response){
        $rows = $request->getDataSet()->getRows();
        try{
            $this->connection->beginTransaction();
            foreach($rows as $classe){
                $this->CANCELA_CLASSE_PLANOVOOM($classe);
            }
            $this->connection->commit();
        } catch(\Exception $e){
            $this->connection->rollback();
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    private function CANCELA_CLASSE_PLANOVOOM($row){
        $procedure = new StoredProcedure($this->connection, 'CANCELA_CLASSE_PLANOVOOM');
        $procedure->addParam(new Param('P_CDFILIAL',      Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',         Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',         Param::PARAM_INPUT, $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',      Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV',  Param::PARAM_INPUT, $row['DTHRPLAVOOPV']));
        $procedure->addParam(new Param('P_CDCLASSE',      Param::PARAM_INPUT, $row['CDCLASSE']));
        $procedure->addParam(new Param('P_CDOPERADOR',    Param::PARAM_INPUT, $this->environment->getCdOperador()));
        $procedure->addParam(new Param('P_NRORG',         Param::PARAM_INPUT, $row['NRORG']));
        $result = $procedure->execute();
    }

    public function deleteClasse($request, $response){
        $rows = $request->getDataSet()->getRows();
        try{
            $this->connection->beginTransaction();
            foreach($rows as $classe){
                $this->EXCLUI_CLASSE_PLANOVOOM($classe);
            }
            $this->connection->commit();
        } catch(\Exception $e){
            $this->connection->rollback();
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    private function EXCLUI_CLASSE_PLANOVOOM($row){
        $procedure = new StoredProcedure($this->connection, 'EXCLUI_CLASSE_PLANOVOOM');
        $procedure->addParam(new Param('P_CDFILIAL',      Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',         Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',         Param::PARAM_INPUT, $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',      Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV',  Param::PARAM_INPUT, $row['DTHRPLAVOOPV']));
        $procedure->addParam(new Param('P_CDCLASSE',      Param::PARAM_INPUT, $row['CDCLASSE']));
        $procedure->addParam(new Param('P_CDOPERADOR',    Param::PARAM_INPUT, $this->environment->getCdOperador()));
        $procedure->addParam(new Param('P_NRORG',         Param::PARAM_INPUT, $row['NRORG']));
        $result = $procedure->execute();
    }

    private function getSituacaoItemDelivery($cdfilial, $cdcia, $nrvoo, $cdtrecho, $cdclasse, $nrorg, $nritemplansp, $dthrplavoopv) {
        
        $sql = "SELECT IDSITSERSP, NRDELIVERY FROM SERVPLANOM
                WHERE CDFILIAL = :CDFILIAL AND
	        CDCIA = :CDCIA AND
	        NRVOO = :NRVOO AND
	        CDCLASSE = :CDCLASSE AND
	        CDTRECHO = :CDTRECHO AND
	        NRORG = :NRORG AND
	        NRITEMPLANSP = :NRITEMPLANSP AND
	        DTHRPLAVOOPV = :DTHRPLAVOOPV";
                
        $params = array(
            'CDFILIAL' => $cdfilial,
            'CDCIA' => $cdcia,
            'NRVOO' => $nrvoo,
            'CDTRECHO' => $cdtrecho,
            'CDCLASSE' => $cdclasse,
            'NRORG' => $nrorg,
            'NRITEMPLANSP' => $nritemplansp,
            'DTHRPLAVOOPV' => $dthrplavoopv
        );

        $query = $this->connection->prepare($sql);
        
        $query->execute($params);
        
        $result = $query->fetch(\PDO::FETCH_ASSOC);
        
        return $result;
        
    }

    public function deleteItem($request, $response) {

        $rows = $request->getDataSet()->getRows();

        try{

            $messages = array();
            $messagesSucess = array();
            $itensDelete = array();
            
            foreach($rows as $row) {

                $status = $this->getSituacaoItemDelivery($row['CDFILIAL'], $row['CDCIA'], $row['NRVOO'], $row['CDTRECHO'], $row['CDCLASSE'], $row['NRORG'], $row['NRITEMPLANSP'], $row['DTHRPLAVOOPV']);

                if($status['IDSITSERSP'] == '1' && empty($status['NRDELIVERY'])) {

                    $row['CDCICLOSP'] = $row['CDCICLO'];
                    $row['CDCLASSESP'] = $row['CDCLASSE'];
                    $row['NRSERVICOCIAFILISP'] = $row['NRSERVICOCIAFILI'];
                    $itensDelete[] = $row;
                    //$messagesSucess[] = "O servico ".$row['DSSERVICOCIAFILI']." foi excluído.";

                }else if($status['IDSITSERSP'] == '2') {
                    
                    $messages[] = "ATE01500_SERV_EMIT" . "#_#" . $row['DSSERVICOCIAFILI'];

                } else if($status['IDSITSERSP'] == '3') {

                    $messages[] = "ATE01500_SERV_CANCEL" . "#_#" . $row['DSSERVICOCIAFILI'];

                }
                
            }

            $newMethod = $request->getMethod();
            $newRoutePath =  $request->getRoutePath();
			$newUserId = $request->getUserId();

	        // apagar registros de log
	        $this->dataSourceName = 'conexaosubgrupo';
	        $newDataSetLog = new DataSet($this->dataSourceName, $itensDelete);
            $newRequestLog = new DTO\Request\DataSet($newDataSetLog, $newMethod, $newRoutePath, $newUserId);
            parent::delete($newRequestLog, $response);
	        
	        
	        // apagar registros da tabela servplanom
            $this->dataSourceName = "servplanom";
            $newDataSetItens = new DataSet($this->dataSourceName, $itensDelete);
            $newRequestItens = new DTO\Request\DataSet($newDataSetItens, $newMethod, $newRoutePath, $newUserId);

	        parent::delete($newRequestItens, $response);
	        
	        //$messages = array_merge($messages, $messagesSucess);
	        
	        foreach($itensDelete as $row){
                $this->REVALIDA_STATUS_PLANOVOOM($row);
            }
	        
            
            
            $response->addDataSet(new DataSet('errorMessages', $messages));
            
        } catch(\Exception $e){
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
            //$this->connection->rollback();
        }
    }

    public function cancelItem($request, $response){
        $rows = $this->crudService->getRowsToSave($request, 'servplanom');
        try{
            $this->connection->beginTransaction();
            $messages = array();
            foreach($rows as &$row){
                //$status = $this->getSituacaoItemDelivery($row['CDFILIAL'], $row['CDCIA'], $row['NRVOO'], $row['CDTRECHO'], $row['CDCLASSE'], $row['NRORG'], $row['NRITEMPLANSP'], $row['DTHRPLAVOOPV']);
                $this->validateItem($row, $messages);
                $row['IDSITSERSP'] = '3';
            }

            if(!empty($messages)){
                $response->addDataSet(new DataSet('errorMessages', $messages));
                $this->connection->rollback();
            } else {
                $this->crudService->save('servplanom', $rows);
                $this->REVALIDA_STATUS_PLANOVOOM($rows[0]);
                $this->connection->commit();
            }
        } catch(\Exception $e){
            $this->connection->rollback();
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    private function ALTERA_CLASSE_PLANOVOOM($row){
        $procedure = new StoredProcedure($this->connection, 'ALTERA_CLASSE_PLANOVOOM');
        $procedure->addParam(new Param('P_CDFILIAL',      Param::PARAM_INPUT, $row['CDFILIAL']));
        $procedure->addParam(new Param('P_CDCIA',         Param::PARAM_INPUT, $row['CDCIA']));
        $procedure->addParam(new Param('P_NRVOO',         Param::PARAM_INPUT, $row['NRVOO']));
        $procedure->addParam(new Param('P_CDTRECHO',      Param::PARAM_INPUT, $row['CDTRECHO']));
        $procedure->addParam(new Param('P_DTHRPLAVOOPV',  Param::PARAM_INPUT, $row['DTHRPLAVOOPV']));
        $procedure->addParam(new Param('P_CDCLASSE',      Param::PARAM_INPUT, $row['CDCLASSE']));
        $procedure->addParam(new Param('P_CDOPERADOR',    Param::PARAM_INPUT, $this->environment->getCdOperador()));
        $procedure->addParam(new Param('P_NRORG',         Param::PARAM_INPUT, $row['NRORG']));
        $result = $procedure->execute();
    }
    
    private function CALCULA_DELIVERYM($nrdelivery, $cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv, $cdagrdeco, $cdlocafatcia, $nrseqdeliver, $cdoperador){
        $procedure = new StoredProcedure($this->connection, 'CALCULA_DELIVERYM');
        $procedure->addParam(new Param('NRDELIVERY',         Param::PARAM_INPUT, null));
        $procedure->addParam(new Param('CDFILIAL',           Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('CDCIA',              Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('NRVOO',              Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('CDTRECHO',           Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('DTHRPLAVOOPV',       Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('CDAGRDECO',          Param::PARAM_INPUT, $cdagrdeco));
        $procedure->addParam(new Param('CDLOCAFATCIA',       Param::PARAM_INPUT, $cdlocafatcia));
        $procedure->addParam(new Param('NRSEQDELIVER',       Param::PARAM_INPUT, $nrseqdeliver));
        $procedure->addParam(new Param('CDOPERADOR',         Param::PARAM_INPUT, $cdoperador));
        $procedure->addParam(new Param('PESOTOTSERV',        Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('TOTALGERALSERV',     Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('VRTAXA',             Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCNOTA',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCSERV',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCDESV',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('PEDESCDESV',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCFIXO',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('PEDESCFIXO',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCCOND',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('PEDESCCOND',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('TOTSBYUT',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('TOTSBYNUT',          Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('VRTOTDESC',          Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('VRUTIDESC',          Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDDESCDESV',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDDESCCOND',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDDESCFIXO',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDINCDESDESV',       Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDINCDESFIXO',       Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDINCDESCOND',       Param::PARAM_OUTPUT, null,null, 20));

        $result = $procedure->execute();

        $arrayResult = array();
        $arrayResult['PESOTOTSERV'] = $result['PESOTOTSERV'];
        $arrayResult['TOTALGERALSERV'] = $result['TOTALGERALSERV'];
        $arrayResult['VRTAXA'] = $result['VRTAXA'];
        $arrayResult['DESCNOTA'] = $result['DESCNOTA'];
        $arrayResult['DESCSERV'] = $result['DESCSERV'];
        $arrayResult['VRDESCDESV'] = $result['DESCDESV'];
        $arrayResult['PEDESCDESV'] = $result['PEDESCDESV'];
        $arrayResult['VRDESCFIXO'] = $result['DESCFIXO'];
        $arrayResult['PEDESCFIXO'] = $result['PEDESCFIXO'];
        $arrayResult['VRDESCCOND'] = $result['DESCCOND'];
        $arrayResult['PEDESCCOND'] = $result['PEDESCCOND'];
        $arrayResult['TOTSBYUT'] = $result['TOTSBYUT'];
        $arrayResult['TOTSBYNUT'] = $result['TOTSBYNUT'];
        $arrayResult['VRTOTDESC'] = $result['VRTOTDESC'];
        $arrayResult['VRUTIDESC'] = $result['VRUTIDESC'];
        $arrayResult['IDDESCDESV'] = $result['IDDESCDESV'];
        $arrayResult['IDDESCCOND'] = $result['IDDESCCOND'];
        $arrayResult['IDDESCFIXO'] = $result['IDDESCFIXO'];
        $arrayResult['IDINCDESDESV'] = $result['IDINCDESDESV'];
        $arrayResult['IDINCDESFIXO'] = $result['IDINCDESFIXO'];
        $arrayResult['IDINCDESCOND'] = $result['IDINCDESCOND'];
        return $arrayResult;
    }
    
    public function getAgrupamentoDelManutencao($request, $response){
        
        $row = $request->getRow();
        
        $sql = "SELECT DISTINCT SP.CDFILIAL,
                      SP.CDCIA,
                      SP.NRVOO,
                      SP.CDTRECHO,
                      SP.DTHRPLAVOOPV,
                      SP.CDAGRDECO,
                      AD.DSDELIVERY DSAGRCORPO,
                      ' ' TXOBSDELTMP,
                      OB.VRDESCDELTMP DESCDELIV,
                      OB.CDCIATMP,
                      SP.NRSEQDELIVER,
                      BO.SGBASE
                      || ' - '
                      || BD.SGBASE AS SGTRECHO,
                      SP.NRORG
                    FROM AGRDELIVERY AD,
                      OBSDELIVTMPM OB,
                      SERVPLANOM SP,
                      BASE BO,
                      BASE BD,
                      VOOTRECHO VT,
                      COMPANHIA CO
                    WHERE(SP.CDCIA       = :CDCIA)
                    AND(SP.NRVOO         = :NRVOO)
                    AND (SP.CDTRECHO     = :CDTRECHO )
                    AND (SP.DTHRPLAVOOPV = :DTHRPLAVOOPV)
                    AND (SP.NRDELIVERY  IS NULL )
                    AND (SP.IDSITSERSP  <> 3 )
                    AND (SP.CDFILIAL     = :CDFILIAL )
                    AND (SP.CDAGRDECO    = AD.CDAGRDEL )
                    AND (SP.CDFILIAL     = OB.CDFILIAL (+))
                    AND (SP.CDCIA        = OB.CDCIATMP (+))
                    AND (SP.NRVOO        = OB.NRVOOTMP (+))
                    AND (SP.CDCIA        = VT.CDCIA )
                    AND (SP.CDTRECHO     = VT.CDTRECHO )
                    AND (SP.CDFILIAL     = VT.CDFILIAL )
                    AND (SP.NRVOO        = VT.NRVOO )
                    AND (BO.CDBASE(+)    = VT.CDBASEORI)
                    AND (BD.CDBASE(+)    = VT.CDBASEDES)
                    AND (SP.DTHRPLAVOOPV = OB.DTHRPLAVOTMP(+))
                    AND (SP.CDAGRDECO    = OB.CDAGRDECOTMP(+))
                    ORDER BY SP.NRSEQDELIVER,
                      AD.DSDELIVERY";
        
        $params = array(
            'CDFILIAL' => $row["CDFILIAL"],
            'CDCIA' => $row["CDCIA"],
            'NRVOO' => $row["NRVOO"],
            'CDTRECHO' => $row["CDTRECHO"],
            'DTHRPLAVOOPV' => $row["DTHRPLAVOOPV"]
        );

        $query = $this->connection->prepare($sql);
        
        $query->execute($params);
        
        $result = $query->fetchAll(\PDO::FETCH_ASSOC);
        
        foreach($result as &$r){
            $valores = $this->CALCULA_DELIVERYM(null, $r["CDFILIAL"], $r["CDCIA"], $r["NRVOO"], 
                                                          $r["CDTRECHO"], $r["DTHRPLAVOOPV"], 
                                                          $r["CDAGRDECO"], null, 
                                                          0, $this->environment->getCdOperador());
            $r["VRDESCDESV"] = ($valores["VRDESCDESV"]) ? $valores["VRDESCDESV"] : 0;
            $r["PEDESCDESV"] = ($valores["PEDESCDESV"]) ? $valores["PEDESCDESV"] : 0;
            $r["VRDESCFIXO"] = ($valores["VRDESCFIXO"]) ? $valores["VRDESCFIXO"] : 0;
            $r["PEDESCFIXO"] = ($valores["PEDESCFIXO"]) ? $valores["PEDESCFIXO"] : 0;
            $r["VRDESCCOND"] = ($valores["VRDESCCOND"]) ? $valores["VRDESCCOND"] : 0;
            $r["PEDESCCOND"] = ($valores["PEDESCCOND"]) ? $valores["PEDESCCOND"] : 0;
            $r["VRTOTDESC"] = ($valores["VRTOTDESC"]) ? $valores["VRTOTDESC"] : 0;
            $r["VRUTIDESC"] = ($valores["VRUTIDESC"]) ? $valores["VRUTIDESC"] : 0;
            $r["VRTXAEROR"] = ($valores["VRTAXA"]) ? $valores["VRTAXA"] : 0;
            $r["TOTALSERV"] = ($valores["TOTALGERALSERV"]) ? $valores["TOTALGERALSERV"] : 0;
            $r["TOTALDEL"] = $r["TOTALSERV"] + $r["VRTXAEROR"] - $r["VRTOTDESC"];
        }
        
        $newDataSet = new DataSet('getAgrupamentoDelManutencao', $result);
		$response->addDataSet($newDataSet);
    }
}