<?php
namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;

class Ate22000RelatorioPlanoDeVoo extends \Zeedhi\Framework\Controller\Report {
    
    protected $birtStrategy;
    protected $environment;

    public function __construct(ReportService $reportService, $birtStrategy, $environment) {
        $this->birtStrategy = $birtStrategy;
        $this->environment  = $environment;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'ATE22001' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL" =>"CDFILIAL",
              "CDCIA"    =>"CDCIA",
              "DATAINI"  =>"DATAINI",
              "DATAFIN"  =>"DATAFIN"
            )
        ),
        'ATE22002' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL" =>"CDFILIAL",
              "CDCIA"    =>"CDCIA",
              "DATAINI"  =>"DATAINI",
              "DATAFIN"  =>"DATAFIN",
              "NRORG"    =>"NRORG"
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        $row['NRORG']  = $this->environment->getNrOrgTrab();
        $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
    }
}
