<?php

namespace Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Exception;

class Ate02200EmissaoDeliveryService extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName;
	protected $crudService;
	protected $dataSourceNameToSave;


    public function __construct($crudService,  $environment, $dataSourceManager) {
        $this->crudService = $crudService;
        $this->environment = $environment;
        $this->dataSourceManager = $dataSourceManager;

    }

    public function saveAgrup ($request, $reponse){
    	$this->dataSourceNameToSave = 'servplanom';
    	parent::save($request,$reponse);
    }

    public function saveObs ($request, $reponse){
    	$this->dataSourceNameToSave = 'obsdelivtmpm';
    	parent::save($request,$reponse);
    }

	//find
    public function findFilial (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'filioper_filial';
        $filterCriteria = $request->getFilterCriteria();

        $filterCriteria->addCondition('CDOPERADOR', "=", $this->environment->getCdOperador());
        $this->parameterBagColumns = array("CDOPERADOR");


        parent::find($request, $response);

    }

    public function findCia (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName='companhia_ciafili_planovoo';
    	$this->parameterBagColumns = array("SGCIA", "DTHRPLAVOOPV", "CDFILIAL","NRORG");

    	parent::find($request, $response);
    }

    public function findVoo (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName='planovoo_vootrecho_base_equipamento';
    	$this->parameterBagColumns = array("CDFILIAL", "CDCIA", "DTHRPLAVOOPV","NRVOO","NRORG");

    	parent::find($request, $response);
    }


    public function findAgrup (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName='agrdelivery_obsdelivtmp_servplano';
    	$this->parameterBagColumns = array("CDCIA", "NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","NRORG");

    	parent::find($request, $response);
    }

    public function findServ (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName='servplanom_servicociafili_classe_ciclo_ciafili';
    	$this->parameterBagColumns = array("CDAGRDECO","CDCIA", "NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","NRORG");

    	parent::find($request, $response);
    }

    public function findTotalServ (DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName='total_servicos';
    	$this->parameterBagColumns = array("CDAGRDECO","CDCIA", "NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","NRORG");

    	parent::find($request, $response);
    }

    //gets dos datasources para serem usados na procedure e na regra de negocio
    public function getVrdescdeltmpTxdescdeltmp($row){
		$row['CDAGRDECO'] = $row["CDAGRDECO"];
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_vrdescdeltmp_txdescdeltmp', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV","CDAGRDECO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getIdtipmanualsp($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_idtipmanualsp', $condition);
		$this->parameterBagColumns = array("CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV","CDFILIAL","CDAGRDECO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getVrindice($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_ciafili_vrindice', $condition);
		$this->parameterBagColumns = array("DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
		return $registrosEncontrados;
    }

    public function getDthrabastpv($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_planovoom_dthrabastpv', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getVraltxport($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_ciafili_vraltxport', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getDefDeliv($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_agrupdeliv', $condition);
		$this->parameterBagColumns = array("DTHRPLAVOOPV","CDFILIAL","CDCIA");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getAgrupDeliv($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_agrupdeliv', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getVerificaNacionalidade($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_verifica_nac', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getTotalServ($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "NRORG",
				"operator" => "=",
				"value" => $row["NRORG"]
			)
		);
		$filterCriteria = new FilterCriteria('total_servicos', $condition);
		$this->parameterBagColumns = array("CDAGRDECO","CDCIA", "NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","NRORG");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getNrservicociafili($row){
    	$this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CIA",
				"operator" => "=",
				"value" => $row["CIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_nrservicociafili', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
    }

    public function getTestaNacionalidade($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_nacionalidade', $condition);
		$this->parameterBagColumns = array("CDAGRDECO","CDCIA","NRVOO", "CDTRECHO","DTHRPLAVOOPV","CDFILIAL");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getUtLocalFatu($row){

	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_ciafili', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getTestaLocalClasse($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDLOCAFATCIA",
				"operator" => "=",
				"value" => ''
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_classecia', $condition);
		$this->parameterBagColumns = array("CDAGRDECO","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","CDLOCAFATCIA");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getTestaLocalVoo($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_vootrecho', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getParamComis($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_paramcomis', $condition);
		$this->parameterBagColumns = array("CDFILIAL");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        // return $this->dataSourceManager->findBy($newFilterCriteria);

        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getSequencialDel($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDCONTADOR",
				"operator" => "=",
				"value" => $row["CDCONTADOR"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_novocodigo', $condition);
		$this->parameterBagColumns = array("CDCONTADOR");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getUltDelivery($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_delivery', $condition);
		$this->parameterBagColumns = array("CDFILIAL");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados[0]['NRDELIVERY'];
	    return [];
	}

	public function getCtrlNumDelFilial($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_ctrlnumdeli', $condition);
		$this->parameterBagColumns = array("CDFILIAL");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getIntervaloEmissDel($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDCTRLNUMDEL",
				"operator" => "=",
				"value" => $row["CDCTRLNUMDEL"]
			),
			array(
				"columnName" => "CDLOCALDELIV",
				"operator" => "=",
				"value" => $row["CDLOCALDELIV"]
			),
			array(
				"columnName" => "NRDELIVERY",
				"operator" => "=",
				"value" => $row["NRDELIVERY"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_seqnumedeli', $condition);
		$this->parameterBagColumns = array("CDCTRLNUMDEL","CDLOCALDELIV","NRDELIVERY");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getProIntervaloEmissDel($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDCTRLNUMDEL",
				"operator" => "=",
				"value" => $row["CDCTRLNUMDEL"]
			),
			array(
				"columnName" => "CDLOCALDELIV",
				"operator" => "=",
				"value" => $row["CDLOCALDELIV"]
			),
			array(
				"columnName" => "NRDELIVERY",
				"operator" => "=",
				"value" => $row["NRDELIVERY"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_seqnumedeli_pro', $condition);
		$this->parameterBagColumns = array("CDCTRLNUMDEL","CDLOCALDELIV","NRDELIVERY");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getMovIndice($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDTPINDICE",
				"operator" => "=",
				"value" => $row["CDTPINDICE"]
			),
			array(
				"columnName" => "CDINDICE",
				"operator" => "=",
				"value" => $row["CDINDICE"]
			),
			array(
				"columnName" => "DATE",
				"operator" => "=",
				"value" => $row["DATE"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_movindice', $condition);
		$this->parameterBagColumns = array("CDTPINDICE","CDINDICE","DATE");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getTipManualSP($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_manual', $condition);
		$this->parameterBagColumns = array("CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","CDAGRDECO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getObsDelivTmpm($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDAGRDECO",
				"operator" => "=",
				"value" => $row["CDAGRDECO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_obsdelivtmpm', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV","CDAGRDECO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getDataServ($row){
	    $this->environment->getCurrentTime()->format("d/m/Y");
	}

	public function getCia($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "SGCIA",
				"operator" => "=",
				"value" => $row["SGCIA"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_companhia_ciafili_planovoom', $condition);
		$this->parameterBagColumns = array("SGCIA","DTHRPLAVOOPV","CDFILIAL");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getDelivComp($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDSERVICO",
				"operator" => "=",
				"value" => $row["CDSERVICO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_delivcomp', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV","CDSERVICO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getExisteDeliv($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_existedeliv', $condition);
        $this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getExisteComp($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_existecomp', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getdelivery($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_agrdelivery_obsdelivtmpm_servplanom', $condition);
		$this->parameterBagColumns = array("CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getTotalProd($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)

		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_totalprod', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getDelivOri($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDSERVICO",
				"operator" => "=",
				"value" => $row["CDSERVICO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_deliviori', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV","CDSERVICO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getTabPreco($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "DTHRABASTPV",
				"operator" => "=",
				"value" => $row["DTHRABASTPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_tabprecose', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getPreProp($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRTABPRECO",
				"operator" => "=",
				"value" => $row["NRTABPRECO"]
			),
			array(
				"columnName" => "CDSERVICO",
				"operator" => "=",
				"value" => $row["CDSERVICO"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_proprecose', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRTABPRECO","CDSERVICO");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getServPlanom($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			),
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_classe_ciclo_servicociafili_servicogen', $condition);
		$this->parameterBagColumns = array("NRVOO","CDTRECHO","DTHRPLAVOOPV","CDFILIAL","CDCIA");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

	public function getServPlanomMax($row){
	    $this->parameterBagColumns = array();
    	$condition = array(
			array(
				"columnName" => "CDFILIAL",
				"operator" => "=",
				"value" => $row["CDFILIAL"]
			),
			array(
				"columnName" => "CDCIA",
				"operator" => "=",
				"value" => $row["CDCIA"]
			),
			array(
				"columnName" => "NRVOO",
				"operator" => "=",
				"value" => $row["NRVOO"]
			),
			array(
				"columnName" => "CDTRECHO",
				"operator" => "=",
				"value" => $row["CDTRECHO"]
			),
			array(
				"columnName" => "DTHRPLAVOOPV",
				"operator" => "=",
				"value" => $row["DTHRPLAVOOPV"]
			)
		);
		$filterCriteria = new FilterCriteria('emissao_delivery_servplanom_max', $condition);
		$this->parameterBagColumns = array("CDFILIAL","CDCIA","NRVOO","CDTRECHO","DTHRPLAVOOPV");
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $registrosEncontrados = $dataSet->getRows();
        if(!empty($registrosEncontrados))
			return $registrosEncontrados;
	    return [];
	}

}